org.codehaus.groovy.transform.sc

## Class StaticCompileTransformation

- java.lang.Object
- - org.codehaus.groovy.transform.StaticTypesTransformation
  - - org.codehaus.groovy.transform.sc.StaticCompileTransformation

- All Implemented Interfaces:
    ASTTransformation

      public class StaticCompileTransformation
      extends StaticTypesTransformation

  Handles the implementation of the `CompileStatic` transformation.

- - ### Field Summary

    - ### Fields inherited from class org.codehaus.groovy.transform.StaticTypesTransformation

      `STATIC_ERROR_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StaticCompileTransformation()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected StaticTypeCheckingVisitor` | `newVisitor(SourceUnit unit, ClassNode node, TypeCheckerPluginFactory pluginFactory)` Allows subclasses to provide their own visitor.
    `void` | `visit(ASTNode[] nodes, SourceUnit source)` The method is invoked when an AST Transformation is active.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StaticCompileTransformation

          public StaticCompileTransformation()

  - ### Method Detail

    - #### visit

          public void visit(ASTNode[] nodes,
                   SourceUnit source)

      Description copied from interface: `ASTTransformation`
      The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
      Specified by:
        `visit` in interface `ASTTransformation`
      Overrides:
        `visit` in class `StaticTypesTransformation`
      Parameters:
        `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
        `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.

    - #### newVisitor

          protected StaticTypeCheckingVisitor newVisitor(SourceUnit unit,
                                             ClassNode node,
                                             TypeCheckerPluginFactory pluginFactory)

      Description copied from class: `StaticTypesTransformation`
      Allows subclasses to provide their own visitor. This is useful for example for transformations relying on the static type checker.
      Overrides:
        `newVisitor` in class `StaticTypesTransformation`
      Parameters:
        `unit` - the source unit
        `node` - the current classnode
      Returns:
        a static type checking visitor